import {
  Column,
  Entity,
  PrimaryGeneratedColumn,
  Tree,
  TreeChildren,
  TreeParent,
} from 'typeorm';

@Entity()
@Tree('closure-table', {
  closureTableName: 'item_closure',
})
export class Item {
  @PrimaryGeneratedColumn('increment', { type: 'bigint' })
  id: string;

  @Column()
  name: string;

  @Column({ nullable: true })
  notes?: string;

  @TreeParent()
  parent?: Item;

  @TreeChildren()
  children: Item[];
}
